unit Main; //29.06.2012

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses Windows,Messages,SysUtils,Variants,Classes,Graphics,Controls,Forms,Dialogs,
     StdCtrls,ExtCtrls;

type TFormOpenGL=class(TForm)
      GroupBox                  :TGroupBox;
      ScrollBarDrehwinkel       :TScrollBar;
      ButtonEnde                :TButton;
      LabelDrehwinkel           :TLabel;
      LabelWinkelperspektive    :TLabel;
      ScrollBarWinkelperspektive:TScrollBar;
      LabelNearClipping         :TLabel;
      ScrollBarNearClipping     :TScrollBar;
      LabelFarClipping          :TLabel;
      ScrollBarFarClipping      :TScrollBar;
      LabelVektorX              :TLabel;
      ScrollBarVektorX          :TScrollBar;
      LabelVektorY              :TLabel;
      ScrollBarVektorY          :TScrollBar;
      LabelVektorZ              :TLabel;
      ScrollBarVektorZ          :TScrollBar;
      LabelTranslationX         :TLabel;
      ScrollBarTranslationX     :TScrollBar;
      LabelTranslationY         :TLabel;
      ScrollBarTranslationY     :TScrollBar;
      LabelTranslationZ         :TLabel;
      ScrollBarTranslationZ     :TScrollBar;
      LabelGroesseX             :TLabel;
      ScrollBarGroesseX         :TScrollBar;
      LabelGroesseY             :TLabel;
      ScrollBarGroesseY         :TScrollBar;
      LabelGroesseZ             :TLabel;
      ScrollBarGroesseZ         :TScrollBar;
      procedure FormCreate(Sender:TObject);
      procedure ButtonEndeClick(Sender:TObject);
      procedure FormDestroy(Sender:TObject);
      procedure ScrollBarDrehwinkelChange(Sender:TObject);
      procedure ScrollBarWinkelperspektiveChange(Sender:TObject);
      procedure ScrollBarNearClippingChange(Sender:TObject);
      procedure ScrollBarFarClippingChange(Sender:TObject);
      procedure ScrollBarVektorXChange(Sender:TObject);
      procedure ScrollBarVektorYChange(Sender:TObject);
      procedure ScrollBarVektorZChange(Sender:TObject);
      procedure ScrollBarTranslationXChange(Sender:TObject);
      procedure ScrollBarTranslationYChange(Sender:TObject);
      procedure ScrollBarTranslationZChange(Sender:TObject);
      procedure ScrollBarGroesseXChange(Sender:TObject);
      procedure ScrollBarGroesseYChange(Sender:TObject);
      procedure ScrollBarGroesseZChange(Sender:TObject);
      procedure Rendern;
     end;

var  FormOpenGL:TFormOpenGL;

implementation

{$R *.dfm}

Uses dglOpenGL;

Var  DC:HDC;
     RC:HGLRC;

procedure TFormOpenGL.FormCreate(Sender:TObject);
begin
 DC:=GetDC(Handle);Randomize;
 if not InitOpenGL then Application.Terminate;
 RC:=CreateRenderingContext(DC,[opDoubleBuffered],32,24,0,0,0,0);
 ActivateRenderingContext(DC,RC);
 glClearColor(0.3,0.4,0.7,0.0);glEnable(GL_DEPTH_TEST);glEnable(GL_CULL_FACE)
end;

procedure TFormOpenGL.ButtonEndeClick(Sender:TObject);
begin Close end;

procedure TFormOpenGL.FormDestroy(Sender:TObject);
begin
 DeactivateRenderingContext;DestroyRenderingContext(RC);ReleaseDC(Handle,DC)
end;

procedure TFormOpenGL.Rendern;
Var x,y,z:Extended;
begin
 glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glMatrixMode(GL_PROJECTION);glLoadIdentity;
 gluPerspective(ScrollBarWinkelperspektive.Position,ClientWidth/ClientHeight,
                ScrollBarNearClipping.Position,ScrollBarFarClipping.Position);
 glMatrixMode(GL_MODELVIEW);glLoadIdentity;
 glScalef(ScrollBarGroesseX.Position,ScrollBarGroesseY.Position,
          ScrollBarGroesseZ.Position);
 glTranslatef(ScrollBarTranslationX.Position,ScrollBarTranslationY.Position,
              ScrollBarTranslationZ.Position);
 glRotatef(ScrollBarDrehWinkel.Position,ScrollBarVektorX.Position,
           ScrollBarVektorY.Position,ScrollBarVektorZ.Position);
 x:=1.5;y:=2;z:=3;
 glBegin(GL_TRIANGLES);
  glColor3f(1,0,0);glVertex3f(-x,y,-z);glVertex3f(x,y,-z);glVertex3f(0,1.5*y,-z);
  glColor3f(0,1,0);glVertex3f(-x,y, z);glVertex3f(x,y, z);glVertex3f(0,1.5*y, z);
 glEnd;
 glBegin(GL_QUADS);
  glColor3f(1,0,0);
  glVertex3f(-1.0*x,-1.00*y,-z);glVertex3f(-0.5*x,-1.00*y,-z);
  glVertex3f(-0.5*x, 1.00*y,-z);glVertex3f(-1.0*x, 1.00*y,-z);
  glVertex3f( 0.5*x,-1.00*y,-z);glVertex3f( 1.0*x,-1.00*y,-z);
  glVertex3f( 1.0*x, 1.00*y,-z);glVertex3f( 0.5*x, 1.00*y,-z);
  glVertex3f(-0.5*x, 0.75*y,-z);glVertex3f( 0.5*x, 0.75*y,-z);
  glVertex3f( 0.5*x, 1.00*y,-z);glVertex3f(-0.5*x, 1.00*y,-z);
  glColor3f(0,1,0);
  glVertex3f(-1.0*x,-1.00*y,z);glVertex3f( 1.0*x,-1.00*y,z);
  glVertex3f( 1.0*x, 0.00*y,z);glVertex3f(-1.0*x, 0.00*y,z);
  glVertex3f(-1.0*x, 0.75*y,z);glVertex3f( 1.0*x, 0.75*y,z);
  glVertex3f( 1.0*x, 1.00*y,z);glVertex3f(-1.0*x, 1.00*y,z);
  glVertex3f(-1.0*x, 0.00*y,z);glVertex3f(-0.4*x, 0.00*y,z);
  glVertex3f(-0.4*x, 0.75*y,z);glVertex3f(-1.0*x, 0.75*y,z);
  glVertex3f( 0.8*x, 0.00*y,z);glVertex3f( 1.0*x, 0.00*y,z);
  glVertex3f( 1.0*x, 0.75*y,z);glVertex3f( 0.8*x, 0.75*y,z);
  glColor3f(0,0,1);
  glVertex3f(-x,-y,-z);glVertex3f(-x,-y, z);
  glVertex3f(-x, y, z);glVertex3f(-x, y,-z);
  glColor3f(1,0,1);
  glVertex3f(x,-y,-z);glVertex3f(x,-y, z);
  glVertex3f(x, y, z);glVertex3f(x, y,-z);
 glEnd;
 SwapBuffers(DC)
end;

procedure TFormOpenGL.ScrollBarDrehwinkelChange(Sender:TObject);
begin
 LabelDrehwinkel.Caption:='Drehwinkel: '+
  IntToStr(ScrollBarDrehwinkel.Position)+'';
 Rendern
end;

procedure TFormOpenGL.ScrollBarWinkelperspektiveChange(Sender:TObject);
begin
 LabelWinkelperspektive.Caption:='Winkelperspektive: '+
  IntToStr(ScrollBarWinkelperspektive.Position)+'';
 Rendern
end;

procedure TFormOpenGL.ScrollBarNearClippingChange(Sender: TObject);
begin
 LabelNearClipping.Caption:='Near-Clipping: '+
  IntToStr(ScrollBarNearClipping.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarFarClippingChange(Sender:TObject);
begin
 LabelFarClipping.Caption:='Far-Clipping: '+
  IntToStr(ScrollBarFarClipping.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarVektorXChange(Sender:TObject);
begin
 LabelVektorX.Caption:='Drehvektor.x: '+IntToStr(ScrollBarVektorX.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarVektorYChange(Sender:TObject);
begin
 LabelVektorY.Caption:='Drehvektor.y: '+IntToStr(ScrollBarVektorY.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarVektorZChange(Sender:TObject);
begin
 LabelVektorZ.Caption:='Drehvektor.z: '+IntToStr(ScrollBarVektorZ.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarTranslationXChange(Sender:TObject);
begin
 LabelTranslationX.Caption:='Translation x: '+IntToStr(ScrollBarTranslationX.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarTranslationYChange(Sender:TObject);
begin
 LabelTranslationY.Caption:='Translation y: '+IntToStr(ScrollBarTranslationY.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarTranslationZChange(Sender:TObject);
begin
 LabelTranslationZ.Caption:='Translation z: '+IntToStr(ScrollBarTranslationZ.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarGroesseXChange(Sender:TObject);
begin
 LabelGroesseX.Caption:='Gre x: '+IntToStr(ScrollBarGroesseX.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarGroesseYChange(Sender:TObject);
begin
 LabelGroesseY.Caption:='Gre y: '+IntToStr(ScrollBarGroesseY.Position);
 Rendern
end;

procedure TFormOpenGL.ScrollBarGroesseZChange(Sender:TObject);
begin
 LabelGroesseZ.Caption:='Gre z: '+IntToStr(ScrollBarGroesseZ.Position);
 Rendern
end;

end.
